class gauges_trike_1 extends TemplateElement {
    constructor() {
        super();
        this.location = "interior";
        this.curTime = 0.0;
        this.bNeedUpdate = false;
        this._isConnected = false;
    }
    get templateID() { return "gauges_trike_1"; }
    connectedCallback() {
        super.connectedCallback();
        let parsedUrl = new URL(this.getAttribute("Url").toLowerCase());
        let updateLoop = () => {
            if (!this._isConnected)
                return;
            this.Update();
            requestAnimationFrame(updateLoop);
        };
        this._isConnected = true;
        requestAnimationFrame(updateLoop);
    }
    disconnectedCallback() {
    }
    Update() {
		this.updateInstruments();
    }
    /*playInstrumentSound(soundId) {
        if (this.isElectricityAvailable()) {
            Coherent.call("PLAY_INSTRUMENT_SOUND", soundId);
            return true;
        }
        return false;
    }	*/
    updateInstruments() {

       // TAXI LIGHTS CONTROL
       if (SimVar.GetSimVarValue("IS GEAR RETRACTABLE", "Boolean")) {
         var gears_extracted = SimVar.GetSimVarValue("GEAR HANDLE POSITION", "Boolean");
         if (SimVar.GetSimVarValue("LIGHT TAXI", "bool") && !gears_extracted)
            SimVar.SetSimVarValue("K:TOGGLE_TAXI_LIGHTS", "bool", false)
         else if (!SimVar.GetSimVarValue("LIGHT TAXI", "bool") && gears_extracted)
            SimVar.SetSimVarValue("K:TOGGLE_TAXI_LIGHTS", "bool", true)
       }


		/* ASI_ALT_READOUT_0 */
		var asi_Alt_Readout_0 = this.querySelector("#asi_Alt_Readout_0");
		if (typeof asi_Alt_Readout_0 !== "undefined") {
		  var transform = '';

			asi_Alt_Readout_0.innerHTML = Math.round( Math.max( Math.min( Math.abs(parseFloat(SimVar.GetSimVarValue("AIRSPEED TRUE", "mph"))), 999 ), 0 ) ).toString() ;

		  if (transform != '')
		    asi_Alt_Readout_0.style.transform = transform; 

		}

		/* ASI_METERS_1 */
		var asi_meters_1 = this.querySelector("#asi_meters_1");
		if (typeof asi_meters_1 !== "undefined") {
		  var transform = '';

			asi_meters_1.innerHTML = "mph";

		  if (transform != '')
		    asi_meters_1.style.transform = transform; 

		}

		/* ALTIMETER_ALT_READOUT_0 */
		var altimeter_Alt_Readout_0 = this.querySelector("#altimeter_Alt_Readout_0");
		if (typeof altimeter_Alt_Readout_0 !== "undefined") {
		  var transform = '';

			altimeter_Alt_Readout_0.innerHTML = Math.round( Math.max( Math.min( Math.abs(( ( 1 == 2 ) ?  parseFloat(SimVar.GetSimVarValue("INDICATED ALTITUDE", "meters")) :  parseFloat(SimVar.GetSimVarValue("INDICATED ALTITUDE", "feet")) )), 99999 ), 0 ) ).toString() ;

		  if (transform != '')
		    altimeter_Alt_Readout_0.style.transform = transform; 

		}

		/* ALTIMETER_ENGLISH_1 */
		var altimeter_English_1 = this.querySelector("#altimeter_English_1");
		if (typeof altimeter_English_1 !== "undefined") {
		  var transform = '';

		  altimeter_English_1.style.display = ( 1 != 2 ) ? "block" : "none";

		  if (transform != '')
		    altimeter_English_1.style.transform = transform; 

		}

		/* ALTIMETER_FEET_2 */
		var altimeter_feet_2 = this.querySelector("#altimeter_feet_2");
		if (typeof altimeter_feet_2 !== "undefined") {
		  var transform = '';

			altimeter_feet_2.innerHTML = "feet";

		  if (transform != '')
		    altimeter_feet_2.style.transform = transform; 

		}

		/* ALTIMETER_BARO_IN_3 */
		var altimeter_Baro_IN_3 = this.querySelector("#altimeter_Baro_IN_3");
		if (typeof altimeter_Baro_IN_3 !== "undefined") {
		  var transform = '';

			altimeter_Baro_IN_3.innerHTML = ( parseFloat(SimVar.GetSimVarValue("KOHLSMAN SETTING HG", "inches of mercury")) ).toFixed(2).toString() + " in" ;

		  if (transform != '')
		    altimeter_Baro_IN_3.style.transform = transform; 

		}

		/* ALTIMETER_METRIC_4 */
		var altimeter_Metric_4 = this.querySelector("#altimeter_Metric_4");
		if (typeof altimeter_Metric_4 !== "undefined") {
		  var transform = '';

		  altimeter_Metric_4.style.display = ( 1 == 2 ) ? "block" : "none";

		  if (transform != '')
		    altimeter_Metric_4.style.transform = transform; 

		}

		/* ALTIMETER_METERS_5 */
		var altimeter_meters_5 = this.querySelector("#altimeter_meters_5");
		if (typeof altimeter_meters_5 !== "undefined") {
		  var transform = '';

			altimeter_meters_5.innerHTML = "meters";

		  if (transform != '')
		    altimeter_meters_5.style.transform = transform; 

		}

		/* ALTIMETER_BARO_IN_6 */
		var altimeter_Baro_IN_6 = this.querySelector("#altimeter_Baro_IN_6");
		if (typeof altimeter_Baro_IN_6 !== "undefined") {
		  var transform = '';

			altimeter_Baro_IN_6.innerHTML = ( parseFloat(SimVar.GetSimVarValue("Kohlsman setting hg", "millibars")) ).toFixed(2).toString() + " mb" ;

		  if (transform != '')
		    altimeter_Baro_IN_6.style.transform = transform; 

		}

		/* ALTIMETER_BARO_PLUS_BUTTON_7 */
		var altimeter_Baro_Plus_Button_7 = this.querySelector("#altimeter_Baro_Plus_Button_7");
		if (typeof altimeter_Baro_Plus_Button_7 !== "undefined") {
		  var transform = '';

		  if (transform != '')
		    altimeter_Baro_Plus_Button_7.style.transform = transform; 

		}

		/* ALTIMETER_BARO_MINUS_BUTTON_8 */
		var altimeter_Baro_Minus_Button_8 = this.querySelector("#altimeter_Baro_Minus_Button_8");
		if (typeof altimeter_Baro_Minus_Button_8 !== "undefined") {
		  var transform = '';

		  if (transform != '')
		    altimeter_Baro_Minus_Button_8.style.transform = transform; 

		}

		/* RPM_ELEMENT_0 */
		var rpm_Element_0 = this.querySelector("#rpm_Element_0");
		if (typeof rpm_Element_0 !== "undefined") {
		  var transform = '';

		  if (transform != '')
		    rpm_Element_0.style.transform = transform; 

		}

		/* RPM_ALT_READOUT_1 */
		var rpm_Alt_Readout_1 = this.querySelector("#rpm_Alt_Readout_1");
		if (typeof rpm_Alt_Readout_1 !== "undefined") {
		  var transform = '';

		  rpm_Alt_Readout_1.style.display = ( parseFloat(SimVar.GetSimVarValue("Var1", "number")) == 0 ) ? "block" : "none";

			rpm_Alt_Readout_1.innerHTML = Math.round( parseFloat(SimVar.GetSimVarValue("General Eng RPM:1", "rpm")) ).toString() ;

		  if (transform != '')
		    rpm_Alt_Readout_1.style.transform = transform; 

		}

		/* RPM_ALT_READOUT_2 */
		var rpm_Alt_Readout_2 = this.querySelector("#rpm_Alt_Readout_2");
		if (typeof rpm_Alt_Readout_2 !== "undefined") {
		  var transform = '';

		  rpm_Alt_Readout_2.style.display = ( parseFloat(SimVar.GetSimVarValue("Var1", "number")) == 1 ) ? "block" : "none";

			rpm_Alt_Readout_2.innerHTML = Math.round( parseFloat(SimVar.GetSimVarValue("General Eng Pct Max RPM:1", "percent")) ).toString() + "%" ;

		  if (transform != '')
		    rpm_Alt_Readout_2.style.transform = transform; 

		}

		/* COMPASS_COMPASS_ROTATING_RING_0 */
		var compass_compass_rotating_ring_0 = this.querySelector("#compass_compass_rotating_ring_0");
		if (typeof compass_compass_rotating_ring_0 !== "undefined") {
		  var transform = '';

		  {

			var ExpressionResult = (parseFloat(SimVar.GetSimVarValue("PLANE HEADING DEGREES MAGNETIC", "radians"))) * (-1); /* PARSED FROM "(A:Magnetic compass,radians) /-/" */
			var Minimum = 0;
			var Maximum = 999999999;
			var PointsTo = 0;
			transform += 'rotate(' + (ExpressionResult * 180 / Math.PI + PointsTo) + 'deg) ';
		  }
		  if (transform != '')
		    compass_compass_rotating_ring_0.style.transform = transform; 

		}

		/* COMPASS_COMPASS_FIXED_POINTER_1 */
		var compass_compass_fixed_pointer_1 = this.querySelector("#compass_compass_fixed_pointer_1");
		if (typeof compass_compass_fixed_pointer_1 !== "undefined") {
		  var transform = '';

		  if (transform != '')
		    compass_compass_fixed_pointer_1.style.transform = transform; 

		}

    }
}
registerLivery("gauges_trike_1-element", gauges_trike_1);
