class gauges_trike_2 extends TemplateElement {
    constructor() {
        super();
        this.location = "interior";
        this.curTime = 0.0;
        this.bNeedUpdate = false;
        this._isConnected = false;
    }
    get templateID() { return "gauges_trike_2"; }
    connectedCallback() {
        super.connectedCallback();
        let parsedUrl = new URL(this.getAttribute("Url").toLowerCase());
        let updateLoop = () => {
            if (!this._isConnected)
                return;
            this.Update();
            requestAnimationFrame(updateLoop);
        };
        this._isConnected = true;
        requestAnimationFrame(updateLoop);
    }
    disconnectedCallback() {
    }
    Update() {
		this.updateInstruments();
    }
    /*playInstrumentSound(soundId) {
        if (this.isElectricityAvailable()) {
            Coherent.call("PLAY_INSTRUMENT_SOUND", soundId);
            return true;
        }
        return false;
    }	*/
    updateInstruments() {

       // TAXI LIGHTS CONTROL
       if (SimVar.GetSimVarValue("IS GEAR RETRACTABLE", "Boolean")) {
         var gears_extracted = SimVar.GetSimVarValue("GEAR HANDLE POSITION", "Boolean");
         if (SimVar.GetSimVarValue("LIGHT TAXI", "bool") && !gears_extracted)
            SimVar.SetSimVarValue("K:TOGGLE_TAXI_LIGHTS", "bool", false)
         else if (!SimVar.GetSimVarValue("LIGHT TAXI", "bool") && gears_extracted)
            SimVar.SetSimVarValue("K:TOGGLE_TAXI_LIGHTS", "bool", true)
       }


		/* FUEL_FUEL_NEEDLE_0 */
		var fuel_fuel_needle_0 = this.querySelector("#fuel_fuel_needle_0");
		if (typeof fuel_fuel_needle_0 !== "undefined") {
		  var transform = '';

		  {

			var ExpressionResult = parseFloat(SimVar.GetSimVarValue("FUEL TANK CENTER QUANTITY", "gallons")) / parseFloat(SimVar.GetSimVarValue("FUEL TANK CENTER CAPACITY", "gallons")); /* PARSED FROM "(A:Fuel tank center level,position)" */
			var Minimum = 0;
			var Maximum = 999999999;
			var PointsTo = 0;
			var NonlinearityTable = [
				[0, 322.411870505904],
				[0.5, 358.137455603667],
				[1.0, 394.578020848705],
			];

			if (NonlinearityTable.length > 0) {
			    Minimum = NonlinearityTable[0][0];
			    ExpressionResult = Math.max(ExpressionResult, Minimum);
			    Maximum = NonlinearityTable[NonlinearityTable.length-1][0];
			    ExpressionResult = Math.min(ExpressionResult, Maximum);
				var prevAngle = 0;
				var result = 0;
				var prevVal = Minimum;
				for (var i = 0; i < NonlinearityTable.length; i++) {
					var NonlinearityEntry = NonlinearityTable[i][0];
					var NonlinearityAngle = NonlinearityTable[i][1];
					if (NonlinearityAngle < 0) { NonlinearityAngle += 360 };
					if (ExpressionResult == NonlinearityEntry || prevAngle == NonlinearityAngle && ExpressionResult > prevVal && ExpressionResult < NonlinearityEntry) {
						result = NonlinearityAngle;
						break;
					}
					else if (ExpressionResult > prevVal && ExpressionResult < NonlinearityEntry ) {
						var coef = 1 - (NonlinearityEntry - ExpressionResult) / (NonlinearityEntry - prevVal);

						result = prevAngle + coef * (NonlinearityAngle - prevAngle);
						break;
					}
					prevVal = NonlinearityEntry;
					prevAngle = NonlinearityAngle;
				}

				if (Minimum >= 0)
					while (result < 0)
						result += 360;

				transform += 'rotate(' + (result + PointsTo) + 'deg) ';
			}

		  }
		  if (transform != '')
		    fuel_fuel_needle_0.style.transform = transform; 

		}

    }
}
registerLivery("gauges_trike_2-element", gauges_trike_2);
